local class = {}


function class:__call(...)
  local o = {}
  if self.ctor then
    self.ctor(o, ...)
  end
  return setmetatable(o, self)
end


local create = {}

create.k = {__mode = "k"}
create.v = {__mode = "v"}


function create:__call(...)
  local c = {}
  c.__index = c
  if ... then
    for n = 1, select("#", ...) do
      for i, f in pairs(class[select(n, ...)]) do
        c[i] = f
      end
      c.ctor = c.ctor and c:ctor()
    end
  end
  return setmetatable(c, class)
end


function create.super(n)
  class[n] = class[n] or {}
  return class[n]
end


function create.mode(i)
  return setmetatable({}, create[i])
end


return setmetatable(create, create)