local class = require "class"

local Event = class.super("Event")

local num = 0
local queue = {}
local toasters = {}
local receivers = {}


function Event:ctor()
  self.name = ""
end


function Event:toast(e)
  num = num + 1
  queue[num] = e
  toasters[num] = self
end


function Event:addHandler(e, f)
  self.handlers = self.handlers or {}
  self.handlers[e] = f or self.handlers[e]
  
  receivers[e] = receivers[e] or class.mode("k")
  receivers[e][self] = true
end


function Event:removeHandler(e)
  receivers[e][self] = nil
end


function Event:getName()
  return self.name
end


function love.run()
  local love = love
  
  if love.load then
    love.load()
  end
  
  love.timer.step()
  
  return function()
    love.event.pump()
    for n, a, b, c, d, e in love.event.poll() do
      if n == "quit" then
        return a or 0
      end
      love.handlers[n](a, b, c, d, e)
    end
    
    if love.update then
      love.update(love.timer.step())
    else
      love.timer.step()
    end
    
    if num > 0 then
      local i = 1
      repeat
        if receivers[queue[i]] then
          for o in pairs(receivers[queue[i]]) do
            o.handlers[queue[i]](o, toasters[i])
          end
          toasters[i] = nil
        end
        i = i + 1
      until i > num
    end
    num = 0
    
    if love.graphics.isActive() then
      love.graphics.origin()
      love.graphics.clear(love.graphics.getBackgroundColor())
      if love.draw then
        love.draw()
      end
      love.graphics.present()
    end
    
    love.timer.sleep(0.001)
  end
end