local class = require "class"

local List = class()


function List:ctor()
  self[1] = {} -- should be weak table
  self[2] = {} -- i set them to strong reference for debug
  self.front = nil
  self.back = nil
end


function List:setFront(e)
  if self.front then
    self:setNext(e, self.front)
  else
    self.back = e
    self.front = e
  end
end


function List:setBack(e)
  if self.back then
    self:setPrevious(e, self.back)
  else
    self.front = e
    self.back = e
  end
end


function List:erase(e)
  if self[1][e] then
    self[2][self[1][e]] = self[2][e]
  elseif e == self.front then
    self.front = self[2][e]
  end
  if self[2][e] then
    self[1][self[2][e]] = self[1][e]
  elseif e == self.back then
    self.back = self[1][e]
  end
  self[1][e] = nil
  self[2][e] = nil
end


function List:setPrevious(e, n)
  if not n then
    if self[1][e] then
      return self:setNext(e, self[1][e])
    end
    return
  end
  self:erase(e)
  if n ~= e then
    if self[2][n] then
      self[1][self[2][n]] = e
      self[2][e] = self[2][n]
      self[2][n] = e
      self[1][e] = n
      return self[2][e]
    elseif n == self.back then
      self.back = e
      self[2][n] = e
      self[1][e] = n
    end
  end
end


function List:setNext(e, n)
  if not n then
    if self[2][e] then
      return self:setPrevious(e, self[2][e])
    end
    return
  end
  self:erase(e)
  if n ~= e then
    if self[1][n] then
      self[2][self[1][n]] = e
      self[1][e] = self[1][n]
      self[1][n] = e
      self[2][e] = n
      return self[1][e]
    elseif n == front then
      self.front = e
      self[1][n] = e
      self[2][e] = n
    end
  end
end


function List:getFront()
  return self.front
end


function List:getBack()
  return self.back
end


function List:getPrevious(e)
  return self[1][e]
end


function List:getNext(e)
  return self[2][e]
end


return List