local class = require "class"

local Object = class.super("Object")


function Object:ctor()
  self.x = 0
  self.y = 0
  self.alpha = 1
end


function Object:setX(x)
  self.x = x
end


function Object:setY(y)
  self.y = y
end


function Object:setPosition(x, y)
  self.x = x
  self.y = y
end


function Object:setAlpha(a)
  self.alpha = a
end


-- simple detection
function Object:focus(x, y, a, b)
  if b then
    return x >= self.x and y >= self.y and a + self.x >= x and b + self.y >= y
  elseif a then
    return --circle
  end
end


function Object:getX()
  return self.x
end


function Object:getY()
  return self.y
end


function Object:getPosition()
  return self.x, self.y
end


function Object:getAlpha()
  return self.alpha
end


local Size = class.super("Size")


function Size:ctor()
  self.width = 0
  self.height = 0
end


function Size:setWidth(w)
  self.width = w
end


function Size:setHeight(h)
  self.height = h
end


function Size:setSize(w, h)
  self.width = w
  self.height = h
end


function Size:getWidth()
  return self.width
end


function Size:getHeight()
  return self.height
end


function Size:getSize()
  return self.width, self.height
end